#include "adv3L.h"
#include <tok.h>
#include <gramprod.h>
#include <tadsio.h>

property quitting;

Doer cmd = 'give Thing to Thing';
Doer cmd = 'give Thing to bob';
Doer cmd = 'put Match in Thing';
Doer cmd = '*';
Doer cmd = '* *';
Doer cmd = '* * *';
Doer cmd = '* * * *';
Doer cmd = 'put Thing in Thing';
Doer cmd = 'light Match|flashlight; burn Match|flashlight';
Doer cmd = 'light Tile|Thing with Match|flashlight';
Doer cmd = 'examine Thing';

Doer cmd = 'quit'
    exec() 
    {
        "Bye!<br>";
        World.quitting = true;
    }
;
    

Doer cmd = 'look around'
    exec()
    {
        /* show the room description for the outermost visible object */
        local loc = me.outermostVisibleParent();
        if (loc != nil)
            loc.lookAround(me);
        else
            "You see nothing.";
    }
;

class Match: Thing
    lit = nil
;

class Tile: Thing
    disambigGroup = Tile
    disambigOrder = (name.toUnicode(1))
;

startRoom: Room 'Start Room' 'start room'
    "This is the boring initial room."
;

+ flashlight: Thing 'flashlight;flash;light'
    light = (lit)
    lit = true
;

+ chair: Thing 'velvet chair'
    enclosing = nil
    fixed = true
    insideDesc(pov) { "You're sitting in a velvet chair."; }
;

++ me: Actor 'me'
    matchPronoun(pro) { return pro == Me || pro == You; }

    name = 'I'
    nameObj = 'me'
    person = 1
;
+++ billfold: Thing 'billfold;blue cloth;wallet'
;

+ redBook: Thing 'red book;; tome'
;
+ blueBook: Thing 'blue book;; tome'
;
+ bob: Actor 'Bob;;; him'
;
++ match4: Match 'match' // Bob's lit match
    lit = true
;

+ bill: Actor 'Bill;;; him'
;
+ table: Thing 'dining table;round wooden cherry'
    contType = On
;
++ jar: Thing 'jar;clear glass'
    disambigName = 'clear glass jar'
    open = nil
    transparent = true
;
+++ beads: Thing 'beads;;; them'
;
    
++ fishBucket: Thing 'bucket'
    distinguishByContents = true
    nominalContents = fish
    enclosing = nil
;
+++ fish: Thing 'fish'
;
++ emptyBucket: Thing 'bucket'
    distinguishByContents = true
    enclosing = nil
;
++ wallet: Thing 'leather wallet;old black'
    owner = [bob]
;
+++ money: Thing 'twenty[n] dollar bill;;20'
;
++ aTile: Tile 'an A[n] tile; from[prep] scrabble set'
;
++ bTile: Tile
    vocab = 'a B[n] tile; from[prep] scrabble set'
;
++ pizzaBox: Thing 'pizza box;greasy cardboard'
;
+++ pizza: Thing 'pizza;large cold half-eaten pepperoni and sausage'
;
++ match3: Match 'match' // lit match on table
    lit = true
;
+shelf: Thing 'shelf'
    contType = On
;
++ waterBucket: Thing 'bucket'
    distinguishByContents = true
    nominalContents = water
    enclosing = nil
;
+++ water: Thing 'some water'
;
++ cTile: Tile 'a C[n] tile; from[prep] scrabble set'
;

+ match1: Match 'match' // lit match on floor
    lit = true
;
+ match2: Match 'match' // unlit match on floor
    lit = nil
;

PreinitObject
    execute()
    {
        local symtab = t3GetGlobalSymbols();
        local revtab = new LookupTable(128, 256);
        symtab.forEachAssoc({ key, val: revtab[val] = key });
        forEachInstance(Action, { a: a.name = revtab[a] });
    }
;

gameMain(args)
{
#ifdef __DEBUG
    DebugCtl.enabled['spelling'] = true;
    DebugCtl.enabled['actions'] = true;
#endif

    World.playerChar = me;

    randomize();
    for (local i = 1 ; i <= 5 ; ++i)
    {
        local r = ['a', 'b', 'c', 'd', 'e', 
            'f', 'g', 'h', 'i', 'j', 
            'k', 'l', 'm', 'n', 'o', 
            'p', 'q', 'r', 's', 't',
            'u', 'v', 'w', 'x', 'y', 'z'].shuffle();
        "<<r.join()>>\n";
    }

    say(typography('Some typographical tests:
        \'single quotes,\' \"double quotes,\"
        \'more single quotes\', \"more double quotes\", some
        dashes---first em, then en--then just a hyphen-dash.\n'));

#if 1
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 1);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 7);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 17);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 37);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 100);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 123);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 4500);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 10000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 12000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 20000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 12600);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 123000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 200000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 123456);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 3000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 3500000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 3560000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 3567000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 30000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 35000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 35600000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 35670000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 135000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 135700000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 200000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 1700000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 1780000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 1789000000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 1789500000);
    DMsg(a, 'Your score is {# 1} point{s} ({1}).\n', 189753.773);

    DMsg(a, 'You are carrying {# 1} item{s}: {and 1}.\n',
         [redBook]);
    DMsg(a, 'You are carrying {# 1} item{s}: {and 1}.\n',
         [redBook, blueBook]);
    DMsg(a, 'You are carrying {# 1} item{s}: {and 1}.\n',
         [redBook, blueBook, wallet]);
        
    forEachInstance(VerbTense, new function(t)
    {
        Narrator.tense = t;
        "\b<b><i>Tense = <<t.name>>...</i></b>\n";

        DMsg(a, 'Taken.\n|{I} {pick} up {the dobj}.\n',
             new Command(Take, wallet));
        DMsg(a, 'Taken.\n|{I} {pick} up {the dobj}.\n',
             new Command(bob, Take, wallet));
        DMsg(a, '{I} {see} no such thing {here}.\n', new Command(Look));
        DMsg(a, '{I} {see} no such thing {here}.\n', new Command(bob, Look));

        DMsg(a, '{I} {don\'t feel} like doing that.\n', new Command(Look));
        DMsg(a, '{I} {don\'t feel} like doing that.\n', new Command(bob, Look));
            
        DMsg(a, '{I} {can\'t} put {the dobj} in {the iobj}.\n',
             new Command(PutIn, pizzaBox, pizzaBox));
        DMsg(a, '{I} {can\'t} put {the dobj} in {the iobj}.\n',
             new Command(PutIn, aTile, pizzaBox));
        DMsg(a, '{I} {can\'t} put {the dobj} in {the iobj}.\n',
             new Command(bob, PutIn, pizzaBox, pizzaBox));
        DMsg(a, '{I} {can\'t} put {the dobj} in {the iobj}.\n',
             new Command(bob, PutIn, bTile, pizzaBox));
        DMsg(a, '{I} {must be} holding {that dobj} first.\n',
             new Command(Take, table));
        DMsg(a, '{I} {must be} holding {that dobj} first.\n',
             new Command(bob, Take, table));

        "\b";
    });
#endif

    local parser = new Parser();
    while (!World.quitting)
    {
        "\b&gt;";
        local txt = inputLine();
        if (txt == 'cls')
        {
            clearScreen();
            continue;
        }

#if 0
        "Plural = <<Thing.pluralNameFrom(txt)>>\n
        A/An = <<Thing.aNameFrom(txt)>>\n";
#endif

        if (txt.startsWith('$'))
        {
            "<hr>";
            txt = txt.substr(2);
            local toks = cmdTokenizer.tokenize(txt);
            local prs = firstCommandPhrase.parseTokens(toks, cmdDict);
            "<b>Found <<prs == nil ? 0 : prs.length()>> grammar matches!</b><p>";
            
            /* build a list of commands for the parse trees */
            prs = prs.mapAll({ p: new Command(p) });
            
            /* sort the list in descending priority order */
            prs = Command.sortList(prs);
            
            foreach (local p in prs)
            {
                "<b>Match:</b><br>";
                
                try
                {
                    p.resolveNouns();
                }
                catch (ParseError err)
                {
                    err.display();
                    "\n";
                }
                
                showNounList('dobj', p.dobjNPs);
                showNounList('iobj', p.iobjNPs);
                showNounList('acc', p.accNPs);
                
                showGrammar(p.parseTree, 0);
                "<p>";
            }
            
            "<p><b>Parse:</b><br>";
        }

        parser.parse(txt);
    }
}

showNounList(name, npLst)
{
    if (npLst != [])
    {
        "<<name>> = [\n";
        foreach (local np in npLst)
        {
            "&ldquo;<<sayTokens(np.tokens)>>&rdquo;
            [core=<<np.coreProd.getText()>>; all=<<np.prod.getText()>>]
            &rarr; ";
            local comma = nil;

            foreach (local o in np.objs)
            {
                if (comma)
                    ", ";
                comma = true;

                "<<o.name>>";
            }
            "\n";
        }
        "]\n";
    }
}

sayTokens(lst)
{
    for (local i = 1, local len = lst.length() ; i <= len ; ++i)
    {
        if (i > 1)
            " ";
        "<<lst[i]>>";
    }
}

sayList(lst)
{
    local comma = nil;
    foreach (local str in lst)
    {
        if (comma)
            ", ";
        comma = true;
        
        "<<str>>";
    }
}

showGrammar(match, indent)
{
  local info;

  /* indent by the desired amount (two spaces per level) */
  for (local i = 0 ; i < indent ; ++i)
    "\ \ ";

  /* if it's not a sub-production, treat it specially */
  if (match == nil)
  {
    /* this tree element isn't used - skip it */
    return;
  }
  else if (dataType(match) == TypeSString)
  {
    /* it's a literal token match - show it */
    "'<<match>>'\n";
    return;
  }

  /* get the grammar info for the object */
  info = match.grammarInfo();

  /* show the production rule name, and the original text it matched */
  "<<info[1]>> [<<showGrammarText(match)>>]\n";

  /* show each sub-match */
  for (local i = 2 ; i <= info.length ; ++i)
    showGrammar(info[i], indent + 1);
}

/* show the text of a match tree item */
showGrammarText(match)
{
  for (local i = match.firstTokenIndex ; i <= match.lastTokenIndex ; ++i)
  {
    /* show a space before each entry except the first */
    if (i != match.firstTokenIndex)
      " ";

    /* show this token's text */
    "<<getTokOrig(match.tokenList[i])>>";
  }
}
